# -*- encoding: utf-8 -*-
#El encoding es para poder hacer comentarios con tildes y esa joda

#Importo las librerias necesarias para el proceso
import numpy as np#Libreŕía para trabajar con matrices  y vectores
import matplotlib.image as mpimg#Librería para guardar imagenes
import matplotlib.pyplot as plt#Librería para mostrar images
#from PIL import Image#Librería para leer imagenes y hacer conversiones
import thinning#Librería para hacer thinning a imágenes
import time#Librería para calcular el tiempo de ejecución del código
#import cv2#Librería para el tratamiento de imágenes
#importo las demás clases creadas para el proceso
import RidgeFreq #Cálculo de la frecuencia de la imagen
import Seg #Segmentación de la imagen
import RidgeFilter #Filtro Gabor de la imagen
import Minucias #Busqueda de minucias
import OrS#Cálculo de la orientación
import CorreccionM#Corección de las minucias


# ----------------
#Función para invertir una imagen (valores) que está en escala de 0 a 255
def invertir (im):
    im2=(255-im)
    return im2
#Función para invertir una imagen (valores) que está en escala de 0.0 a 1.0
def invertird (im):
    im2=(1-im)
    return im2

#Proceso completo de extracción de minucias
def extraerMinucias(image):

    # Normalizacion de la imagen
    # La imagen se normaliza con media y desviación estándar requerida
    t0=time.time() #Calculo el tiempo de ejecúción en esta sección del código
    reqmean = 0 #Media que quiero que tenga mi imagen
    reqvar = 1 #Varianza que quiero que tenga mi imagen
    thresh = 0.2 #Threshold permitido para binarizar mi zona de trabajo
    filas, columnas = image.shape #Obtengo el tamaño de la imagen
    image = Seg.im2double(image) #Convierto la imagen a double
    means = image.mean() #Calculo la media de la imagen.
    stds = image.std() #Calculo la desviación de la imagen
    im = image - means #Le resto a la imagen la media
    im = im / stds #Divido la imagen sobre la desviación estándar
    a=reqmean + im * np.sqrt(reqvar) #Creo mi nueva imagen con los parámetros dados
    #a = Seg.im2double(a)
    #print "Image normalised = {}" .format(time.time()-t0) #Imprimo un mensaje en pantalla para avisar que ya se hizo la normalización
    t11=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    #Imprimo el tiempo de ejecución del código

    # Segmentación de la imagen
    B1 = np.zeros((filas, columnas)) #Creo una imagen de ceros
    blksize = 12 #Defino el tamaño de mi bloque para realizar la segmentación
    imagen, B, B1 = Seg.segmentation(a, filas, columnas, blksize, B1, thresh, im) #Calculo la segmentación de mi imagen
    print "Segmentation done = {}" .format(time.time()-t11) #Imprimo un mensaje en pantalla para avisar que ya se hizo la segmentación
    t1=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    #Imprimo el tiempo de ejecución del código
    #plt.hist(imagen.ravel(), bins=256, range=(0.0, 1.0), fc='k', ec='k')
    #plt.show()
    #plt.hist(imagen)
    #plt.show()
    mpimg.imsave("1Normalizada.png", imagen, cmap="gray")
    mpimg.imsave("2Mascara.png", B, cmap="gray")
    print a.var()

    #fig, ax = plt.subplots()

    #im = ax.imshow(B1, cmap='gray')
    #fig.colorbar(im)
    #plt.show()

    # Orientacion de la imagen
    OrientSmoothSigma = 5 #Determino mi desviación estándar para el filtro gaussiano que se aplicará a la matriz de orientación
    Or = OrS.Orient(imagen, OrientSmoothSigma) #Calculo la orientación de la imagen.
    print "Image orientation calculated = {}" .format(time.time()-t1) #Imprimo un mensaje en pantalla para avisar que ya se hizo la orientación
    t2=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    #Imprimo el tiempo de ejecución del código
    mpimg.imsave("3Orientacion.png", Or, cmap="gray")


    # Cálculo de la frecuencia de la imagen
    blksize = 36 #Defino el tamaño de mi bloque para realizar la segmentación
    freq, medfreq = RidgeFreq.rf(imagen, B, Or, blksize, 3, 2, 15) #Calculo la matrix de frecuencias y la mediana de la frecuencia de la imagen
    print "Image frequency calculated = {}" .format(time.time()-t2 ) #Imprimo un mensaje en pantalla para avisar que ya se calculó la frecuencia
    t3=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    mpimg.imsave("4Frecuencia.png", freq, cmap="gray")
    #Imprimo el tiempo de ejecución del código
    freq = medfreq*B/2.85 #Se demostró empíricamente que el filtro funciona mejor con la mediana de la frecuencia de la imagen sobre 3,5
    #mpimg.imsave("4Frecuencia.png", freq, cmap="gray") #Se guarda la matrix de frecuencia como una imagen


    # Filtrado de la imagen
    newim = RidgeFilter.ridgefilter(imagen, Or, freq, 0.5, 0.5, 0.8) #Se hace el filtro gabor de la imagen
    mpimg.imsave("5FiltroGaborsinb.png", newim, cmap="gray")
    print "Gabor filter done = {}" .format(time.time()-t3) #Imprimo un mensaje en pantalla para avisar que ya se hizo el filtro
    t4=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    #Imprimo el tiempo de ejecución del código
    #Para binarizar la imagen se aplica un threshold
    #mt1=np.nonzero(B==0)

    mt = np.nonzero(newim >= 0)
    newim[mt] = 255
    mt = np.nonzero(newim < 0)
    newim[mt] = 0
    mpimg.imsave("5FiltroGabor.png", newim, cmap="gray")

    # Thining de la imagen
    newim = np.asarray(newim, dtype='uint8') #Convierto la imagen en uint8
    imthin = thinning.guo_hall_thinning(invertir(newim)) #Hago el thinning de la imagen con la función que tiene python
    print "Thining done = {}" .format(time.time()-t4) #Imprimo un mensaje en pantalla para avisar que ya se hizo el thinning
    t5=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    #Imprimo el tiempo de ejecución del código
    img=invertir(imthin*B) #Invierto la imagen, el thinning la entrega invertida (ve tú a saber por qué)
    mpimg.imsave("6Thinning.png", img, cmap="gray")

    # Cálculo de minucias
    result, PosT, PosB = Minucias.BuscarMinucias(img, B) #Busco las minucias en la imagen
    print "Minutiaes calculated = {}" .format(time.time()-t5) #Imprimo un mensaje en pantalla para avisar que ya se encontraron las minucias
    t6=time.time() #Calculo el tiempo de ejecución hasta este punto del código
    #Imprimo el tiempo de ejecución del código

    #En un bloque de tamaño blksizeC solo quiero critB bifurcaciones  y  critT terminaciones
    blksizeC=5
    critB = 1
    critT = 1
    #Defino un bloque de búesqueda (lol) y defino mis criterios de búsqueda, siguiendo el ejemplo, solo voy a permitir una bifurcación y, o, u una terminación dentro de ese bloque
    #Las repetidas las elimino
    #PosT, PosB = CorreccionM.correccion(PosT, PosB, blksizeC, critB, critT) #Corrijo las minucias con los criterios anteriormente dados
    #Creo una variable temporal para guardar mi matrix corregida
    tempos=np.nonzero(PosT)
    #En una matrix aparte guardo todas las bifurcaciones y en otra todas las terminaciones.
    #Col 1 Pos X
    #Col 2 Pos Y
    #Col 3 Tipo de minucia 1 Terminación, 3 Bifurcación
    #Col 4 Orientación de la minucia
    MatrixT=np.zeros((tempos[0].size,4))
    MatrixT[0:len(tempos[0]),0]=tempos[0]
    MatrixT[0:len(tempos[0]),1]=tempos[1]
    MatrixT[0:len(tempos[0]),2]=1
    MatrixT[0:len(tempos[0]),3]=Or[tempos]

    tempos=np.nonzero(PosB)
    MatrixB=np.zeros((tempos[0].size,4))
    MatrixB[0:len(tempos[0]),0]=tempos[0]
    MatrixB[0:len(tempos[0]),1]=tempos[1]
    MatrixB[0:len(tempos[0]),2]=3
    MatrixB[0:len(tempos[0]),3]=Or[tempos]
    #Nótese que la T y la B  de las matrices de arriba son Terminación y Bifurcación, respetivamente.
    MatrixM=np.concatenate((MatrixT, MatrixB), axis=0) #Concateno mos matrices.
    result = Minucias.BuscarMinuciasC(img,PosT,PosB)
    print "Total time = {}" .format(time.time()-t0) #Imprimo un mensaje en pantalla para avisar que ya se se realizó todo el proceso
    #Imprimo el tiempo de ejecución del código
    #result.show() #Muestro en pantalla la imagen con minucias corregidas
    result.save("7Minucias.png")
    return MatrixM #Retorno la matrix de minucias.
