# -*- encoding: utf-8 -*-
# Metody biometryczne
# Przemyslaw Pastuszka

from PIL import Image, ImageDraw
import numpy as np
import Seg

cells = [(-1, -1), (-1, 0), (-1, 1), (0, 1), (1, 1), (1, 0), (1, -1), (0, -1), (-1, -1)]
def invertird (im):
    im2=(1-im)
    return im2

def BuscarM(pixels, i, j):
    #El cálculo de minucias se hace por sumatorias
    values = [pixels[i + k,j + l] for k, l in cells]
    crossings = 0
    for k in range(0, 8):
        crossings += abs(values[k] - values[k + 1])
    crossings /= 2
    if pixels[i,j] == 1:
        if crossings == 1:
            return "terminacion"
        if crossings == 3:
            return "bifurcacion"
    return "nada"


def BuscarMinuciasC(im, PosT, PosB):
    pixels = Seg.im2double(im)
    pixels = invertird(pixels)
    x, y = im.shape
    im = Image.fromarray(np.uint8(im))
    result = im.convert("RGB")
    draw = ImageDraw.Draw(result)
    ellipse_size = 2
    for i in range(5, x - 5):
        for j in range(5, y - 5):
            if PosT[i,j] == 1:
                draw.ellipse([(j - ellipse_size, i - ellipse_size), (j + ellipse_size, i + ellipse_size)],
                             outline=(150, 0, 0))
            else:
                if PosB[i,j] == 3:
                    draw.ellipse([(j - ellipse_size, i - ellipse_size), (j + ellipse_size, i + ellipse_size)],
                                 outline=(0, 150, 0))
    del draw
    return result

def BuscarMinucias(im, B):
    pixels = Seg.im2double(im)#Convierto la imagen a double
    pixels = invertird(pixels)#Invierto la imagen
    x, y = im.shape#Obtengo el tamaño de la imagen
    im = Image.fromarray(np.uint8(im))#Convierto la imagen a uint8
    result = im.convert("RGB")
    #draw = ImageDraw.Draw(result)
    #colors = {"terminacion": (150, 0, 0), "bifurcacion": (0, 150, 0)}
    #ellipse_size = 2
    resultadoB = np.zeros((x, y))#Creo una matriz de ceros para almacenar las minucias encontradas
    resultadoT = np.zeros((x, y))
    crt=25
    for i in range(crt, x - crt):#Recorro toda la imagen buscando minucias
        for j in range(crt, y - crt):
            #El condicional es para decir que si hay una terminación o una bifurcación, que esté alejada del borde de mi zona de trabajo, esto para eliminar falsas minucias
            if (B[i,j]==1 and B[i-crt,j]==1 and B[i,j-crt]==1 and B[i+crt,j]==1 and B[i,j+crt]==1 and B[i+crt,j+crt]==1 and B[i-crt,j+crt]==1 and B[i-crt,j-crt]==1 and B[i+crt,j-crt]==1):
                #Con esto evito que tome como "terminaciones" las zonas donde termina la zona de trabajo
                minucias = BuscarM(pixels, i, j)
                if minucias == "terminacion": #Clasifico mi tipo de minucia, 1 terminacion, 3 bifurcacion
                    resultadoT[i,j] = 1
                else:
                    if minucias == "bifurcacion":
                        resultadoB[i,j] = 3
                #if minucias != "nada":
                #    draw.ellipse([(j - ellipse_size, i - ellipse_size), (j + ellipse_size, i + ellipse_size)], outline = colors[minucias])

    return result, resultadoT, resultadoB
