# -*- encoding: utf-8 -*-
import numpy as np
from scipy.ndimage.filters import gaussian_filter
import cv2


def Orient(im, OrientSmoothSigma):
    #Calculo el sobel en x y en y de toda la imagen
    sobelx = cv2.Sobel(im, cv2.CV_64F, 1, 0, ksize=3)
    sobely = cv2.Sobel(im, cv2.CV_64F, 0, 1, ksize=3)
    #Obtengo mi matrix de orientación
    orient = np.arctan2((sobely), (sobelx))
    #Calculo los ángulos en x y en y, esto para evitar pérdidas de datos (según el pinche libro drogo ese)
    Ox = np.cos(2 * orient)
    Oy = np.sin(2 * orient)
    #Hago un filtro gaussiano para suavizar la matriz
    sin2theta = gaussian_filter(Oy, OrientSmoothSigma, 0)
    cos2theta = gaussian_filter(Ox, OrientSmoothSigma, 0)
    #Reconstruyo mi matrix de orientacón
    orient = (np.arctan2(sin2theta, cos2theta) / 2)
    return orient