# -*- encoding: utf-8 -*-
import numpy as np
import cv2
import time
import timeit
import warnings

def fxn():
    warnings.warn("deprecated", DeprecationWarning)

with warnings.catch_warnings():
    warnings.simplefilter("ignore")
    fxn()
# ------------
#@numba.jit()
def im2double(im):
    min_val = np.min(im.ravel())
    max_val = np.max(im.ravel())
    out = (im.astype('float') - min_val) / (max_val - min_val)
    return out
#@numba.jit()
def rotateImage(image, angle):
    image_center = tuple(np.array(image.shape)/2)
    rot_mat = cv2.getRotationMatrix2D(image_center, angle, 1.0)
    result = cv2.warpAffine(image, rot_mat, image.shape, flags=cv2.INTER_LINEAR)
    return result

#@numba.jit()
def ridgefilter(im, orient, freq, kx, ky, showfilter):
    #Se determina un incremento de 3° para las orientaciones del filtro
    angleInc = 3
    im = im2double(im)
    filas = len(im)
    columnas = len(im[0])
    #Se encuentra donde los valores de frecuencia son válidos
    x1 = np.nonzero(freq > 0)
    validr = x1[0]
    validc = x1[1]
    #Se redondea el array de frecuencias a la centésima más cercana (0.01) para reducir el número de frecuencias
    #presentes en el vector
    freq = np.round(freq*100)/100
    #Se genera un array de las frecuencias únicas en la imagen
    unfreq = np.unique(freq)
    unfreq = unfreq[1:len(unfreq)]
    #Se genera una tabla, dada la frecuencia multiplicada por 100 para obtener un indice entero, y se le asigna esa frecuencia
    #multiplicada al indice
    freqindex = np.ones((len(unfreq), 1))
    #Se generan lo filtros correspondientes a las distintas frecuencias y orientaciones (con los incrementos mencionados antes)
    sze = np.zeros((len(unfreq), 1))
    sigmax = 1 / unfreq[0] * kx
    sigmay = 1 / unfreq[0] * ky
    sze[0] = np.round(1* max(sigmax, sigmay))
    dtype_filter = "(" + str(int(sze[0]*2+1)) + "," + str(int(sze[0]*2+1)) + ")float64"
    sigmax = 1/unfreq*kx
    sigmay = 1/unfreq*ky
    sze = np.round(3*max(sigmax, sigmay))
    x = np.linspace(-sze, sze, sze*2+1)
    y = np.linspace(-sze, sze, sze*2+1)
    [x, y] = np.meshgrid(x, y)
    reffilter = np.exp(-(x**2/sigmax**2 + y**2/sigmay**2)/2)*np.cos(2*np.pi*unfreq*x)
    #Cada filtro para cada frecuencia se rota angleInc veces en sentido antihorario (por eso el -)
    o=0
    filter=np.zeros((180/angleInc,len(x),len(y)))
    while(o<180/angleInc):
    #for o in range(1, 180/angleInc+1, 1):
        tempimg = rotateImage(reffilter, -(o-1)*angleInc)
        filter[o - 1, 0:len(x), 0:len(y)]=tempimg
        o += 1
    #Se buscan los indices de la matrix de puntos mas grandes que maxsze
    maxsze = sze
    finalind1=np.asarray(np.all(((validr>maxsze),(validr<(filas-maxsze)),(validc>maxsze),(validc<(columnas-maxsze))),axis=0))
    finalind=np.nonzero(finalind1==True)
    #Se convierten los valores de la orientación en radianes a un valor entero que corresponda o más se acerque a los
    #angulos calculados por round/degrees/angleInc)
    maxorientindex = np.round(180/angleInc)
    orientindex = np.round(orient/np.pi*180/angleInc)
    i = np.nonzero(orientindex < 1)
    #for up in range(0,len(i)-1,1):
    orientindex[i] = orientindex[i]+maxorientindex
    i = np.nonzero(orientindex > maxorientindex)
    #for up in range(0,len(i)-1,1):
    orientindex[i] = orientindex[i]-maxorientindex
    # Filtrado
    newimg=np.zeros((filas, columnas))
    sze=int(sze)
    #freqindex=int(freqindex)
    im1 = np.zeros((filas + 2 * sze, columnas + 2 * sze))
    im1[sze:filas + sze, sze:columnas + sze] = im
    #im1=im
    s=sze
    k = 0
    newim=np.ones((s,s))
    while (k < finalind[0].size):
        r = validr[(finalind[0][k])]
        c = validc[(finalind[0][k])]
        #Para cada zona válida de la imagen, habrá un valor en frecuencia y orientación, de mi matrix de orientación y mi matrix de frecuencia
        #obtengo los datos y realizo el filtro. No solo se toma el punto, se toma un bloque con el punto a filtrar como centro
        newim = np.multiply(filter[int(orientindex[r, c] - 1), :, :], im1[r - s + s:r + s + s + 1, c - s + s:c + s + s + 1])
        newimg[r, c] = newim.sum()#Se hace una sumatoria de los valores del bloque filtrado
        k += 1
    return newimg
