# -*- encoding: utf-8 -*-
import numpy as np
import copy
# ---------------------

def im2double(im):
    #Función para hacer la conversión de una imange uint8 a double
    min_val = np.min(im.ravel())
    max_val = np.max(im.ravel())
    out = (im.astype('float') - min_val) / (max_val - min_val)
    return out

def im2int(im):
    #Función para convertir una imagen a uint8
    out = (im.astype('int') * 255)
    return out

# Segmentación de la imagen
# Cálculo de la zona de trabajo
def segmentation(a, filas, columnas, blksize, B, thresh, im):
    fil=int(np.fix(filas/blksize)*blksize)+blksize
    col=int(np.fix(columnas/blksize)*blksize)+blksize
    #Rocorro la imagen completamente, bloque por bloque, calculando la varianza del bloque, ese valor de varianza lo guardo
    #en una matriz, en la posición que ocupaba el bloque en la matriz original (me hice bolita? (._.)?)
    #Además se aplica el threshold, si la varianza es menor a mi thresh, reemplace por 0, sino, reemplace con 1.
    for i in range(0, fil, blksize):
        for j in range(0, col, blksize):
            if ((i + blksize) < filas) & ((j + blksize) < columnas):#revisa bloque por bloque calculando la varianza
                if (a[range(i, i + blksize, 1),:][:,range(j, j + blksize, 1)].var() <= thresh):
                    B[i:i+blksize,j:j+blksize]=0
                else:
                    B[i:i+blksize,j:j+blksize]=1
            if ((i + blksize) > filas) and ((j + blksize) > columnas):#si el bloque pasa las filas y las columnas tomamos la posición final menos blksize
                if (a[range(filas - blksize, filas, 1),:][:, range(columnas - blksize, columnas, 1)].var() <= thresh):
                    B[filas-blksize:filas, columnas:columnas - blksize]=0
                else:
                    B[filas-blksize:filas, columnas:columnas - blksize]=1
            if ((i + blksize) > filas) and ((j + blksize) < columnas):#si el bloque pasa las filas, tomamos la posicón final del bloque en filas
                if (a[range(filas - blksize, filas, 1), :][:,range(j, j + blksize, 1)].var() <= thresh):
                    B[filas-blksize:filas, j:j + blksize]=0
                else:
                    B[filas-blksize:filas, j:j + blksize]=1
            if ((j + blksize) > columnas) and ((i + blksize) < filas):#si el bloque pasa las filas, tomamos la posicón final del bloque en columnas
                if (a[range(i, i + blksize, 1), :][:,range(columnas - blksize, columnas, 1)].var() <= thresh):
                    B[i:i + blksize, columnas:columnas - blksize]=0
                else:
                    B[i:i + blksize, columnas:columnas - blksize]=1
            #j+=blksize
        #i+=blksize
    # Threshold de la segmentación
    B1 = copy.copy(B)

    mt = np.nonzero(B > 0)
    # Máscara de la huella: zona de trabajo
    # Normalización de la zona de trabajo
    mediah = np.mean(im[mt[0], mt[1]])
    im1 = im - mediah
    stdh = np.std(im1[mt[0], mt[1]])
    im1 = im1 / stdh
    im2 = im2double(im1)
    #Ya terníamos normalizada la imagen, pero ha zonas basura que no nos interesan, ahora se normaliza la zona de trabao de la imagen.
    return im2, B, B1
